
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 450
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_ARB_shader_draw_parameters : require
#extension GL_ARB_shader_ballot : require

out float gl_ClipDistance[1];

invariant gl_Position;

struct unaligned_float3
{
    float x;
    float y;
    float z;
};

struct S_TBN
{
    int _iNormal;
    int _iTangent;
};

struct S_INDICES
{
    uint _uiObjectIndex;
    uint _uiMaterialIndex;
    uint _uiMaterialInstanceIndex;
    uint _uiLastFrameMaterialIndex;
    uint _uiLastFrameMaterialInstanceIndex;
    uint _uiPositionsBufferIndex;
    uint _uiPrevPositionsBufferIndex;
    uint _uiNormalsBufferIndex;
    uint _uiPositionOffset;
    uint _uiPrevPositionOffset;
    uint _uiNormalOffset;
    uint _uiMatricesIndex;
};

struct S_MAIN_DEFAULT
{
    S_INDICES _Indices;
};

struct S_MAIN_DEFAULT_ARRAY
{
    S_MAIN_DEFAULT _aMain[32];
};

struct S_MESH_OBJECT
{
    mat4 _mModel;
    mat4 _mModelLast;
    mat4 _mInvModel;
    mat4 _mInvModelLast;
    vec4 _vDiversityOffset;
    uint _uiSceneZoneIndex;
    uint _uiNeighborSceneZoneIndex;
    uint _uiDisplayFlags;
    uint _uiPackedLocalExposureCompensation;
    vec4 _vPortalDirAndDistance;
    int _iPickingID[2];
    float _fLocalExposureCompensation;
    float _fLocalExposureCompensationEV100;
};

struct S_MATERIAL
{
    vec4 _vErrorColor;
    float _fDepthBias;
    float _fDummy0;
    float _fDummy1;
    float _fDummy2;
    float c0;
    float c1;
    float c2;
    float c3;
    uint s0;
    uint s1;
    uint s2;
    uint s3;
    uint s4;
    uint s5;
    uint s6;
    uint s7;
    uint s8;
    uint s9;
    uint s10;
    uint s11;
};

struct S_MATERIAL_INSTANCE
{
    float c0;
    float c1;
    float c2;
    float c3;
    float _fGloubiboulga;
};

struct S_PASS_MATRICES
{
    mat4 _mViewJitteredProj;
    mat4 _mViewProj;
    mat4 _mView;
    mat4 _mInvView;
    mat4 _mJitteredProj;
};

struct S_EYE_DATA
{
    S_PASS_MATRICES _mCurrentFrameMatrices[2];
    S_PASS_MATRICES _mPreviousFrameMatrices[2];
    mat4 _mJitteredProjection[2];
    mat4 _mNoJitterProjection[2];
    mat4 _mInvViewJitteredProj[2];
    vec4 _vWorldSpaceCameraVector[2];
    vec4 _vWorldSpaceCameraPosition[2];
    vec4 _vFrameBufferScale;
    vec4 _vFrameBufferViewportSize;
    vec4 _vFrameBufferOneOnViewportSize;
    vec4 _vViewportSize;
    vec4 _vFogSubCrop;
    uint _uiAlignment0;
    uint _uiAlignment1;
    float _vCameraJitterDeltaX;
    float _vCameraJitterDeltaY;
    vec4 _vfRcpFVolumetricFogDepthTileSize;
};

struct S_CASCADED_SHADOW
{
    mat4 _mCascadeMatrix[2][8];
    mat4 _mViewSpaceToStaticShadowMapSpace[2];
    vec4 _vfCascadeShadowAttenuation;
    vec4 _vfShadowCascadeTextureTexelSize;
    vec4 _vfStaticShadowBlurRadius;
    vec4 _vfCascadeLinearZProjFactors[8];
    vec4 _vfCascadeParams[8];
};

struct S_CLUSTER_LIGHT_SETUP
{
    S_CASCADED_SHADOW _CascadedShadow;
    vec4 _vfSkinUVParamsAndNormalBias;
    vec4 _vfShadowTextureTexelSize;
    vec4 _vfDummy_SkinFresnelF0AndF90;
    uint _uiCascadedUsed;
    float _fSSSWidth;
    float _fOffsetBias;
    float _fDummy;
};

struct S_CLUSTER_INFO
{
    mat4 _mViewToClusterView[2];
    mat4 _mClusterProjMatrix;
    mat4 _mClusterInvProjMatrix;
    vec4 _vfLeftEyeToCombinedEyeVsDeltaXZ;
    uint _uiFinestMipWidth;
    uint _uiFinestMipHeight;
    uint _uiFinestMipDepth;
    uint _uiFinestMipWidthHeight;
    float _fZSliceGeomFactor;
    float _fRcpLogZSliceGeomFactor;
    float _fDummy0;
    float _fDummy1;
    float _fNearP;
    float _fInvNearP;
    float _fFarP;
    float _fClusterCoincidentWithCamera;
};

struct S_PASS
{
    S_EYE_DATA _EyeData;
    vec4 _avFrustumCorners[4];
    vec4 _vTime;
    vec4 _cFogColor;
    vec4 _vFogSetup;
    vec4 _cSunColor;
    vec4 _vSunDir;
    vec4 _vProjectionSetup;
    vec4 _vProjectionCoeff;
    vec4 _vOutputColor;
    vec4 _vfVsClippingPlane[2];
    S_CLUSTER_LIGHT_SETUP _LightSetup;
    S_CLUSTER_INFO _ClusterInfo;
    float _fIBLIntensity;
    float _fGIIntensity;
    float _fAmbiantOcclusionDirectIntensity;
    float _fAmbiantOcclusionIndirectIntensity;
    float _fNormalSign;
    int _iFogType;
    float _fSelfOcclusionDebugRatio;
    float _fEmissive;
    int _iEnableSkinSSSSS;
    int _iUseHairOpaquePrepass;
    float _fLocalSceneExposure;
    uint _uiDebugMode;
    uint _sFlags;
    float _fTAADropsSharpness;
    uint _uNeoScaleX;
    uint _uNeoScaleY;
    uint _uiDirectOverdrawFilter;
    float _fCoderTest0;
    float _fCoderTest1;
    float _fCoderTest2;
    uint _uiBakeOutput;
    float _fDefaultAmbientIntensity;
    float _fDefaultLightingIntensity;
    uint _uiOutputColor;
    float _fAARotation;
    float _fClampDirectSpecular;
    float _fNearPlane;
    float _fFarPlane;
    float _fNDFFilteringScreenSpaceVariance;
    float _fNDFFilteringThreshold;
    float _fNDFFilteringScreenSpaceVariance_EyeShader;
    float _fNDFFilteringThreshold_EyeShader;
    float _fSurfaceGradientTextureFiltering;
    float _fZero;
    uint _uDepthClamp;
    uint _uiLightDebugMode;
    vec4 _vfFragCoordToDepthTexFactor;
    vec4 _vfFragCoordToDepthTexFactor_HalfRes;
    uint _uHdr;
    uint _uiDrawMayaSwatch;
    float _fEyeRoughnessBias;
    float _fDummy1;
};

layout(set = 1, binding = 39, std430) readonly buffer g_rbVertices_Layout
{
    unaligned_float3 g_rbVertices[];
} g_rbVertices_Buffer[];

layout(set = 1, binding = 40, std430) readonly buffer g_rbTBNs_Layout
{
    S_TBN g_rbTBNs[];
} g_rbTBNs_Buffer[];

layout(set = 0, binding = 52, std140) uniform dyn_CONSTANT_BUFFER_BLOCK_CB_S_MAIN_ARRAY_BINDING
{
    S_MAIN_DEFAULT_ARRAY g_cbMainArray;
} _1150;

layout(set = 1, binding = 33, std430) readonly buffer g_rbObjects_Layout
{
    S_MESH_OBJECT g_rbObjects[];
} g_rbObjects_Buffer[];

layout(set = 1, binding = 34, std430) readonly buffer g_rbMaterials_Layout
{
    S_MATERIAL g_rbMaterials[];
} g_rbMaterials_Buffer[];

layout(set = 1, binding = 35, std430) readonly buffer g_rbMaterialInstances_Layout
{
    S_MATERIAL_INSTANCE g_rbMaterialInstances[];
} g_rbMaterialInstances_Buffer[];

layout(set = 2, binding = 53, std140) uniform dyn_CONSTANT_BUFFER_BLOCK_CB_S_PASS_BINDING
{
    S_PASS g_cbPass;
} _1395;

layout(set = 1, binding = 12) uniform sampler2D g_rb2DTextures[];

layout(location = 8) in vec2 in_uv0;
layout(location = 23) out float interp_instanceID;

vec3 _7584;

void main()
{
    int _1140 = gl_InstanceIndex + gl_DrawIDARB;
    int _1141 = readFirstInvocationARB(_1140);
    uint _3061 = uint(gl_VertexIndex);
    uint _3064 = _3061 + _1150.g_cbMainArray._aMain[_1141]._Indices._uiPositionOffset;
    uint _3084 = _3061 + _1150.g_cbMainArray._aMain[_1141]._Indices._uiNormalOffset;
    int _3113 = g_rbTBNs_Buffer[_1150.g_cbMainArray._aMain[_1141]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3084]._iNormal & 1023;
    int _3116 = (g_rbTBNs_Buffer[_1150.g_cbMainArray._aMain[_1141]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3084]._iNormal >> 10) & 1023;
    int _3119 = (g_rbTBNs_Buffer[_1150.g_cbMainArray._aMain[_1141]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3084]._iNormal >> 20) & 1023;
    int _7571;
    if (_3113 > 512)
    {
        _7571 = _3113 | (-1024);
    }
    else
    {
        _7571 = _3113;
    }
    int _7573;
    if (_3116 > 512)
    {
        _7573 = _3116 | (-1024);
    }
    else
    {
        _7573 = _3116;
    }
    int _7575;
    if (_3119 > 512)
    {
        _7575 = _3119 | (-1024);
    }
    else
    {
        _7575 = _3119;
    }
    float _3162 = float(_7571);
    float _3165 = float(_7573);
    float _3168 = float(_7575);
    vec3 _3169 = vec3(_3162, _3165, _3168);
    vec3 _3172 = _3169 * vec3(0.001956947147846221923828125);
    vec4 _3295 = vec4(g_rbVertices_Buffer[_1150.g_cbMainArray._aMain[_1141]._Indices._uiPositionsBufferIndex].g_rbVertices[_3064].x, g_rbVertices_Buffer[_1150.g_cbMainArray._aMain[_1141]._Indices._uiPositionsBufferIndex].g_rbVertices[_3064].y, g_rbVertices_Buffer[_1150.g_cbMainArray._aMain[_1141]._Indices._uiPositionsBufferIndex].g_rbVertices[_3064].z, 1.0);
    vec4 _3296 = g_rbObjects_Buffer[_1150.g_cbMainArray._aMain[_1141]._Indices._uiObjectIndex].g_rbObjects[0]._mModel * _3295;
    vec3 _3297 = _3296.xyz;
    mat3 _3454 = mat3(g_rbObjects_Buffer[_1150.g_cbMainArray._aMain[_1141]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[0].xyz, g_rbObjects_Buffer[_1150.g_cbMainArray._aMain[_1141]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[1].xyz, g_rbObjects_Buffer[_1150.g_cbMainArray._aMain[_1141]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[2].xyz);
    vec3 _3457 = _3454 * _3172;
    vec2 _3652 = in_uv0 * vec2(3.0, 2.0);
    vec3 _7517 = _7584;
    _7517.y = textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1150.g_cbMainArray._aMain[_1141]._Indices._uiMaterialIndex].g_rbMaterials[0].s0], _3652 + vec2(-0.100000001490116119384765625, -1.10000002384185791015625), 0.0).x;
    vec3 _3670 = vec3(g_rbMaterialInstances_Buffer[_1150.g_cbMainArray._aMain[_1141]._Indices._uiMaterialInstanceIndex].g_rbMaterialInstances[0].c0);
    vec3 _3673 = mod(_3670, vec3(2.0));
    vec3 _3677 = _7517 * _3673;
    vec3 _7526 = _7584;
    _7526.y = textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1150.g_cbMainArray._aMain[_1141]._Indices._uiMaterialIndex].g_rbMaterials[0].s0], (in_uv0 * vec2(3.0)) + vec2(-0.20000000298023223876953125, -2.099999904632568359375), 0.0).y;
    vec3 _3707 = _3670 * vec3(0.100000001490116119384765625);
    vec3 _3710 = floor(_3707);
    vec3 _3714 = mod(_3710, vec3(2.0));
    vec3 _3718 = _7526 * _3714;
    vec3 _3722 = vec3(1.0) - _3677;
    vec3 _3725 = vec3(1.0) - _3718;
    vec3 _3726 = _3722 * _3725;
    vec3 _7535 = _7584;
    _7535.y = textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1150.g_cbMainArray._aMain[_1141]._Indices._uiMaterialIndex].g_rbMaterials[0].s0], _3652 + vec2(0.0, -1.10000002384185791015625), 0.0).z;
    vec3 _3758 = _3670 * vec3(0.00999999977648258209228515625);
    vec3 _3761 = floor(_3758);
    vec3 _3765 = mod(_3761, vec3(2.0));
    vec3 _3769 = _7535 * _3765;
    vec3 _3776 = vec3(1.0) - _3769;
    vec3 _3777 = _3726 * _3776;
    vec3 _3779 = vec3(1.0) - _3777;
    float _3781 = _3779.y;
    float _3786 = _3781 - 0.949999988079071044921875;
    float _3791 = _3786 * 19.9959964752197265625;
    float _3792 = clamp(_3791, 0.0, 1.0);
    float _3793 = mix(0.0, 1.0, _3792);
    float _3801 = _3781 - 0.88999998569488525390625;
    float _3806 = _3801 * 99.90019989013671875;
    float _3807 = clamp(_3806, 0.0, 1.0);
    float _3808 = mix(0.0, 1.0, _3807);
    vec3 _3813 = vec3(_3808);
    vec3 _3814 = mix(vec3(0.0), vec3(-0.011610000394284725189208984375), _3813);
    vec3 _3819 = vec3(_3793);
    vec3 _3820 = mix(_3814, vec3(-0.019349999725818634033203125), _3819);
    vec3 _3826 = _3820 * _3457;
    vec3 _3834 = vec3(g_rbMaterialInstances_Buffer[_1150.g_cbMainArray._aMain[_1141]._Indices._uiMaterialInstanceIndex].g_rbMaterialInstances[0].c1);
    vec3 _3835 = mix(vec3(0.0), _3826, _3834);
    vec3 _3858 = _3297 + _3835;
    float _3923 = _3858.x;
    float _3924 = _3858.y;
    float _3925 = _3858.z;
    vec4 _3926 = vec4(_3923, _3924, _3925, 1.0);
    vec4 _3927 = _1395.g_cbPass._EyeData._mCurrentFrameMatrices[0]._mView * _3926;
    vec4 _3943 = _1395.g_cbPass._EyeData._mCurrentFrameMatrices[0]._mViewJitteredProj * _3926;
    vec4 _7581;
    if (_1395.g_cbPass._uDepthClamp == 4294967295u)
    {
        float _3958 = _3943.w;
        vec4 _7582;
        if ((_3943.z / _3958) > 1.0)
        {
            vec4 _7583;
            if (_3927.z > _1395.g_cbPass._fNearPlane)
            {
                vec4 _7548 = _3943;
                _7548.z = _3958;
                _7583 = _7548;
            }
            else
            {
                _7583 = _3943;
            }
            _7582 = _7583;
        }
        else
        {
            _7582 = _3943;
        }
        _7581 = _7582;
    }
    else
    {
        _7581 = _3943;
    }
    interp_instanceID = float(_1140) + 0.5;
    float _2947 = _3927.x;
    float _2948 = _3927.y;
    float _2949 = _3927.z;
    vec4 _2950 = vec4(_2947, _2948, _2949, 1.0);
    float _2951 = dot(_1395.g_cbPass._vfVsClippingPlane[0], _2950);
    float _2952 = -_2951;
    gl_ClipDistance[0] = _2952;
    gl_Position = _7581;
}

